import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.net.URL;


class JIVAboutDialog extends JDialog {

	public JIVAboutDialog(ImageViewer owner) {

		super(owner, "About");

		buildGUI();

		// center the dialog over the main window
                int width = 600;
                int height = 570;
                setSize(width, height);
                Point p = owner.getLocationOnScreen();
		Dimension d = owner.getSize();
		Rectangle rect = new Rectangle(p, d);
                setLocation( (rect.x + ((rect.width - width)/2)),
		               (rect.y + ((rect.height - height)/2)) );

	}

	private void buildGUI() {

		StringBuffer contents = new StringBuffer(500);
		contents.append("       JImageView\n");
        	contents.append("       Written by Joseph McMurry (jcmcmurr@eos.ncsu.edu)\n");
        	contents.append("       Distributed under the terms of the GPL (version 2)\n\n");

        	contents.append( readGPL() );

        	JTextArea textArea = new JTextArea(30, 40);
        	textArea.setEditable(false);
        	JScrollPane scrollPane = new JScrollPane(textArea);
                textArea.setText( contents.toString() );
                textArea.setCaretPosition(0);

                setDefaultCloseOperation(DISPOSE_ON_CLOSE);
                setContentPane(scrollPane);
                pack();

	}

	private StringBuffer readGPL() {

		try {
        	     StringBuffer all;
        	     URL url = ClassLoader.getSystemResource("GPL.txt");
        	     BufferedReader br = new BufferedReader( new InputStreamReader( url.openStream() ) );

                     String part;
	             all = new StringBuffer(500);

	             while ( ( part = br.readLine() ) != null) {
	                   all.append(part);
	                   all.append('\n');
                     }

	             br.close();

		     return all;
                }
                catch (Exception e) { }

                return null;

	}

}
